Subject: [Supa] SUPA-Intent =? ANMA-Intent

From: Laurent Ciavaglia <[email-masked]>
Date: Wed, 22 Jul 2015 19:34:50 +0200

Dear SUPA-ers and ANIMA-ers,

In today's SUPA BoF session, the question has been raised several times 
on the Intent as defined in the SUPA or ANIMA WGs.

I would like to understand better if there are any real differences 
between the two. Please do enlighten me with your knowledge ;)

My current/limited understanding is that:
     -SUPA has a definition for Intent. 
https://tools.ietf.org/html/draft-strassner-supa-generic-policy-info-model-02
     -ANIMA (via RFC 7575) also has a definition. 
https://tools.ietf.org/html/rfc7575
     -ANIMA-Intent IDs exist. 
http://tools.ietf.org/html/draft-du-anima-an-intent ; 
http://tools.ietf.org/html/draft-liu-anima-intent-distribution
     -SUPA is not focusing on autonomic networks, but is not excluding them.
     -ANIMA is not chartered to work on policy based management, but is 
not excluding it.

To me, the work of both working groups could be mutually beneficial:
     -ANIMA work on Intent is still nascent and the concept a bit 
"blurry" (but we are working our way up).
     -SUPA work on Intent seems already well-structured/planned.
     -Even though ANIMA has not recognized explicitly Intent as a 
chartered work item, Intent (its role and functioning) is an essential 
element of an ANIMA-based network.
     -ANIMA could be a nice application domain for SUPA (and then SUPA 
would also cover "new" types of networks, i.e. autonomic ones).
     -I see the technologies of the two groups complementary to each 
others, and that could address one of the comments raised by Benoit to 
Oscar on the actual use of such technologies. I think that combining 
SUPA and ANIMA solutions could really benefit and simplify the life of 
operators.

Note: this is _NOT_ an attempt to prevent SUPA to form as a working 
group, neither is it proposing to merge SUPA work with ANIMA. It is just 
a suggestion to share work that seems connected early in the process so 
that it is more efficient on the long run.

Thanks, best regards, Laurent.

-- 

Bien cordialement, Best regards,

*Laurent Ciavaglia*

Secure Cloud Networking

Bell Labs | Alcatel Lucent

phone: +33 160 402 636

email: [email-masked] 
<mailto:[email-masked]>

linkedin: laurentciavaglia <http://fr.linkedin.com/in/laurentciavaglia/>

address: Route de Villejust | 91620 Nozay | France

---

From: "Natale, Bob" <[email-masked]>
Date: Thu, 23 Jul 2015 06:20:44 +0000

Hi Brian,

AFAIK, the existing posted SUPA documents do not cite RFC 7575 as a source for the meaning of intent, but I believe that the RFC 7575 definition matches the meaning of the term as it is being used in the SUPA discussions and supporting artifacts at present.

John Strassner would be the authoritative source to confirm, deny, or modify that assertion, however.

Avanti,
BobN

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Brian E Carpenter
Sent: Thursday, July 23, 2015 2:01 AM
To: Laurent Ciavaglia <[email-masked]>; anima <[email-masked]>; [email-masked]
Subject: Re: [Anima] SUPA-Intent =? ANMA-Intent

Hi Laurent,
On 23/07/2015 05:34, Laurent Ciavaglia wrote:
> In today's SUPA BoF session, the question has been raised several times on the Intent as defined in the SUPA or ANIMA WGs.

Unfortunately I did not attend that session, so excuse the lack of context in my comments below.

> https://tools.ietf.org/html/draft-strassner-supa-generic-policy-info-m

I didn't find a definition there; I did find several references to "intent-based"
as if that is a well understood phrase. So the first question is whether the definition in RFC 7575 is the one assumed in the SUPA documents.

>     -ANIMA (via RFC 7575) also has a definition. https://tools.ietf.org/html/rfc7575
>     -ANIMA-Intent IDs exist. 
> http://tools.ietf.org/html/draft-du-anima-an-intent ; http://tools.ietf.org/html/draft-liu-anima-intent-distribution
>     -ANIMA is not chartered to work on policy based management, but is not excluding it.

Certainly, Intent is out of scope of the initial ANIMA charter, and that is explicitly to avoid boiling the ocean. Of course we are aware that Intent has to be handled later. The current idea is that Intent will most likely be distributed using the synchronization mode of GRASP (future name of GDNP).
GRASP carefully does not restrict the format of the data objects that it transmits, so whatever format ANIMA later chooses for Intent is OK.

>     -ANIMA work on Intent is still nascent and the concept a bit "blurry" (but we are working our way up).
> chartered work item, Intent (its role and functioning) is an essential element of an ANIMA-based network.

Isn't the opposite equally true: SUPA is a nice use case for ANIMA?

> Oscar on the actual use of such technologies. I think that combining SUPA and ANIMA solutions could really benefit and simplify the life of operators.
> 
> group, neither is it proposing to merge SUPA work with ANIMA. It is 
> just a suggestion to share work that seems connected early in the process so that it is more efficient on the long run.

I'm uncertain whether we can say much more at present. Frankly I would hate to see ANIMA bogged down in endless information model discussions that are likely to follow any attempt to share an Intent approach with SUPA. But if the chairs and ADs see obviously orthogonal approaches emerging in the two efforts, that would be a Bad Thing and they should try to prevent it.

    Brian

_______________________________________________
Anima mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/anima

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 23 Jul 2015 09:02:44 +0200

You refer to this text:

   Intent: An abstract, high-level policy used to operate the network.
   Its scope is an autonomic domain, such as an enterprise network.  It
   does not contain configuration or information for a specific node
   (see Section 3.2 on how Intent coexists with alternative management
   paradigms).  It may contain information pertaining to a node with a
   specific role (for example, an edge switch) or a node running a
   specific function.  Intent is typically defined and provided by a
   central entity.

I do not think this serves as a universal definition of intent since
it ties into autonomic domain which again ties into autonomic nodes.

Anyway, within SUPA, the preferred distinction is made between Event
Condition Action Policies and Declarative Policies. The problem with
intend is that some associate a declarative style with intent while
others don't. The definition above kind of equates intent with
network-wide policy vs. node-specific policy.

Bottom line: Intent has recently popped up as a new hype word and
people use it with various definitions and this complicates
communication - but this is exactly what hype words are good for.

/js

On Thu, Jul 23, 2015 at 06:20:44AM +0000, Natale, Bob wrote:
> Supa mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/supa

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: "Natale, Bob" <[email-masked]>
Date: Thu, 23 Jul 2015 07:39:49 +0000

I am generally a more "liberal" reader (in Jon Postel's sense) than Juergen and he (rightly) often calls me out on it ... yet, I persist. :-)  In this case (RFC 7575), however, it seems fairly easy to extract the universal meaning from the autonomic networking content ... also, while "intent" might not have been used as much as "goal" until recently, as a type of policy-based management, it has been around a long time (as long as I have been studying PBNM, and that's measured in decades now) ... a lot of people* are encountering it as "intent" for the first time and not bothering to research the history or the theory behind it -- as happens on almost every front these days, it seems -- and that leads to a lot of confusion and inefficiency ... but dealing with that seems one of the cost factors of progress at present. The silent mapping from "Intent-based" to "Goal-based" is part of the "liberal" reading style that I practice.

[* - I am explicitly excluding the active contributors to the IETF initiatives involved here from that group ... I know that many of them/you are more knowledgeable than I am on these topics ... but I encounter this phenomenon so frequently in my "day job" technical domains that it is impossible to not acknowledge it.]

Avanti,
BobN

-----Original Message-----
From: Brian E Carpenter [mailto:[email-masked]] 
Sent: Thursday, July 23, 2015 3:11 AM
To: Natale, Bob <[email-masked]>; Laurent Ciavaglia <[email-masked]>; [email-masked]; anima <[email-masked]>
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent

Juergen,

Indeed, we should avoid meaningless words, which is why I asked about the definition. I don't find the ANIMA definition meaningless, and we already have at least one proposed concrete example of Intent for a specific use case.

Regards
   Brian

On 23/07/2015 19:02, Juergen Schoenwaelder wrote:
>>> https://tools.ietf.org/html/draft-strassner-supa-generic-policy-info
>>> -m
>>> odel-02
>>
>>>     -ANIMA could be a nice application domain for SUPA (and then 
>>> SUPA would also cover "new" types of networks, i.e. autonomic ones).
>>
>>> others, and that could address one of the comments raised by Benoit 
>>> to Oscar on the actual use of such technologies. I think that combining SUPA and ANIMA solutions could really benefit and simplify the life of operators.
>>>

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 23 Jul 2015 10:31:04 +0200

> Indeed, we should avoid meaningless words, which is why I asked about the definition. I don't find the ANIMA definition meaningless, and we already have at least one proposed concrete example of In…

Brian,

I did not mean to say the RFC 7575 definition is 'meaningless' - you
introduced that word. I am simply saying that I think the RFC 7575
definition was not written as a universal definition of 'intent' and I
tried to explain that within SUPA we prefer to avoid this term
(because people use it with different interpretations).

/js

---

From: Brian E Carpenter <[email-masked]>
Date: Thu, 23 Jul 2015 18:01:16 +1200

Hi Laurent,
> In today's SUPA BoF session, the question has been raised several times on the Intent as defined in the SUPA or ANIMA WGs.

Unfortunately I did not attend that session, so excuse the lack of context
in my comments below.

> 
> I would like to understand better if there are any real differences between the two. Please do enlighten me with your knowledge ;)
> 
>     -SUPA has a definition for Intent. https://tools.ietf.org/html/draft-strassner-supa-generic-policy-info-model-02

I didn't find a definition there; I did find several references to "intent-based"
as if that is a well understood phrase. So the first question is whether
the definition in RFC 7575 is the one assumed in the SUPA documents.

>     -ANIMA-Intent IDs exist. http://tools.ietf.org/html/draft-du-anima-an-intent ;

Certainly, Intent is out of scope of the initial ANIMA charter, and that is
explicitly to avoid boiling the ocean. Of course we are aware that Intent
has to be handled later. The current idea is that Intent will most likely be
distributed using the synchronization mode of GRASP (future name of GDNP).
GRASP carefully does not restrict the format of the data objects that it
transmits, so whatever format ANIMA later chooses for Intent is OK.

>     -Even though ANIMA has not recognized explicitly Intent as a chartered work item, Intent (its role and functioning) is an
> essential element of an ANIMA-based network.
>     -ANIMA could be a nice application domain for SUPA (and then SUPA would also cover "new" types of networks, i.e. autonomic
> ones).

>     -I see the technologies of the two groups complementary to each others, and that could address one of the comments raised by
> Benoit to Oscar on the actual use of such technologies. I think that combining SUPA and ANIMA solutions could really benefit and
> simplify the life of operators.
> 
> Note: this is _NOT_ an attempt to prevent SUPA to form as a working group, neither is it proposing to merge SUPA work with
> ANIMA. It is just a suggestion to share work that seems connected early in the process so that it is more efficient on the long
> run.

I'm uncertain whether we can say much more at present. Frankly I would hate to see
ANIMA bogged down in endless information model discussions that are likely to
follow any attempt to share an Intent approach with SUPA. But if the chairs
and ADs see obviously orthogonal approaches emerging in the two efforts,
that would be a Bad Thing and they should try to prevent it.

    Brian

---

From: Brian E Carpenter <[email-masked]>
Date: Thu, 23 Jul 2015 19:11:03 +1200

Juergen,

Indeed, we should avoid meaningless words, which is why I asked
about the definition. I don't find the ANIMA definition meaningless,
and we already have at least one proposed concrete example
of Intent for a specific use case.

Regards
   Brian

---

From: Duzongpeng <[email-masked]>
Date: Thu, 23 Jul 2015 07:57:49 +0000

Hi Brian, Juergen, and Natale:

	I want to share some personal understandings here. Welcome for comment.

	Certainly, there are some relationships between SUPA-Intent and ANIMA-Intent, but the imaging of two groups' intent may be different.
	Also, it seems like that the two groups have chosen different ways of defining Intent.

	SUPA has chosen an up-to-bottom way to explore the abstract model suitable for all possibilities first.
	ANIMA has chosen a bottom-to-up way to define Intent one-by-one and only when necessary.

	In details, ANIMA will focus on the intent used in autonomic network. Perhaps each Intent will be addressed by a document addressing the specific application environment of the Intent, such as the "prefix management" intent defined in [I-D.jiang-anima-prefix-management].

Best Regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Natale, Bob
Sent: Thursday, July 23, 2015 3:40 PM
To: Brian E Carpenter; Juergen Schoenwaelder; Laurent Ciavaglia
Cc: anima; [email-masked]
Subject: Re: [Anima] [Supa] SUPA-Intent =? ANMA-Intent
Importance: Low

Avanti,
BobN

-----Original Message-----
From: Brian E Carpenter [mailto:[email-masked]]
Sent: Thursday, July 23, 2015 3:11 AM
To: Natale, Bob <[email-masked]>; Laurent Ciavaglia <[email-masked]>; [email-masked]; anima <[email-masked]>
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent

Juergen,

Regards
   Brian

---

From: John Strassner <[email-masked]>
Date: Thu, 23 Jul 2015 10:06:46 +0000

Hi Laurent,
I personally agree with you. I think that SUPA (still in BoF stage) could benefit by looking at what ANIMA is trying to achieve, and that ANIMA could benefit by considering the merits of using a logic-based approach for defining intent.
best regards,
John

John Strassner, Ph.D.
CTO, Software Laboratory, CRD

Futurewei Technologies
US R&D Center
2330 Central Expressway
Building A, office A2-2143
Santa Clara, California   95050

  Office:  +1.408.330.4923
  Email:   [email-masked]<mailto:[email-masked]>

From: Supa [mailto:[email-masked]] On Behalf Of Laurent Ciavaglia
Sent: Wednesday, July 22, 2015 10:35 AM
To: anima; [email-masked]
Subject: [Supa] SUPA-Intent =? ANMA-Intent

    -ANIMA-Intent IDs exist. http://tools.ietf.org/html/draft-du-anima-an-intent ; http://tools.ietf.org/html/draft-liu-anima-intent-distribution

To me, the work of both working groups could be mutually beneficial:
    -ANIMA work on Intent is still nascent and the concept a bit "blurry" (but we are working our way up).
    -SUPA work on Intent seems already well-structured/planned.
    -Even though ANIMA has not recognized explicitly Intent as a chartered work item, Intent (its role and functioning) is an essential element of an ANIMA-based network.
    -ANIMA could be a nice application domain for SUPA (and then SUPA would also cover "new" types of networks, i.e. autonomic ones).
    -I see the technologies of the two groups complementary to each others, and that could address one of the comments raised by Benoit to Oscar on the actual use of such technologies. I think that combining SUPA and ANIMA solutions could really benefit and simplify the life of operators.

Note: this is NOT an attempt to prevent SUPA to form as a working group, neither is it proposing to merge SUPA work with ANIMA. It is just a suggestion to share work that seems connected early in the process so that it is more efficient on the long run.

Laurent Ciavaglia
Secure Cloud Networking

phone: +33 160 402 636
email: [email-masked]<mailto:[email-masked]>
linkedin: laurentciavaglia<http://fr.linkedin.com/in/laurentciavaglia/>
address: Route de Villejust | 91620 Nozay | France

---

From: John Strassner <[email-masked]>
Date: Thu, 23 Jul 2015 10:12:28 +0000

Hi Brian, please see inline...

best regards,
John

-----Original Message-----
From: Supa [mailto:[email-masked]] On Behalf Of Brian E Carpenter
Sent: Wednesday, July 22, 2015 11:01 PM
To: Laurent Ciavaglia; anima; [email-masked]
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent

Hi Laurent,

<jcs>
In SUPA, we instead use "declarative policy", as most of us find
"intent-based" too prone to misunderstanding. This is defined in
page 1 of the draft "A framework for defining a policy model that
uses a declarative (e.g., intent-based) paradigm; this is called
the SUPA Logic Statement Information Model (LSIM)". Definitions
are provided in sections 3.2.4 (background terminology). More
precisely: "This document defines two forms of SUPALogicStatements.
The first uses Propositional Logic (PL, see Section 3.2.4.2), while
the second uses First-Order Logic (FOL, see Section 3.2.4.3)."

Second, I personally cannot understand the definition of intent in
RFC7575. I don't know how to build such a policy from this
description. I do know how to build such a policy from the SUPA
definition.

Hence, I don't know how to answer your question Brian, but I would
HOPE that they either end up the same, or are at least closely
related.
</jcs>

<jcs>
I think that SUPA's logic-based declarative policies (our name for "intent")
could also be transmitted using GRASP.
</jcs>

<jcs>
YES!
</jcs>

<jcs>
Right now, I don't see ANIMA defining an information model, so I'm not
sure I understand your comment about modeling. In SUPA, our aim is to
finish the info model as quickly as possible - hopefully within 3
months, as I stated yesterday. Note that SUPA is NOT chartered to
define a language.
</jcs>

    Brian

---

From: John Strassner <[email-masked]>
Date: Thu, 23 Jul 2015 10:17:06 +0000

I'm not sure about being "authoritative" :-) but I can answer the question:

NO, SUPA has right now NOT referenced the definition of intent in RFC7575. This was because I personally found it too abstract to make use of.

regards,
John

John Strassner, Ph.D.

Futurewei Technologies
US R&D Center
2330 Central Expressway
Building A, office A2-2143
Santa Clara, California   95050
  Office:  +1.408.330.4923
  Email:   [email-masked]

-----Original Message-----
From: Supa [mailto:[email-masked]] On Behalf Of Natale, Bob
Sent: Wednesday, July 22, 2015 11:21 PM
To: Brian E Carpenter; Laurent Ciavaglia; [email-masked]
Cc: anima
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent

Hi Brian,

Avanti,
BobN

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Brian E Carpenter
Sent: Thursday, July 23, 2015 2:01 AM
To: Laurent Ciavaglia <[email-masked]>; anima <[email-masked]>; [email-masked]
Subject: Re: [Anima] SUPA-Intent =? ANMA-Intent

Hi Laurent,

    Brian

---

From: John Strassner <[email-masked]>
Date: Thu, 23 Jul 2015 10:17:07 +0000

I agree with Juergen.

regards,
John

John Strassner, Ph.D.
CTO, Software Labs, Huawei Technologies
2330 Central Expressway
San Jose, CA  95050

-----Original Message-----
From: Supa [mailto:[email-masked]] On Behalf Of Juergen Schoenwaelder
Sent: Thursday, July 23, 2015 12:03 AM
To: Natale, Bob
Cc: Laurent Ciavaglia; anima; Brian E Carpenter; [email-masked]
Subject: Re: [Supa] [Anima]SUPA-Intent =?ANMA-Intent

You refer to this text:

/js

---

From: John Strassner <[email-masked]>
Date: Thu, 23 Jul 2015 10:17:39 +0000

Indeed, Bob is correct. For example, Jeff Kephart from IBM Research and I gave a policy tutorial at NOMS 2006 where we talked about three types of policies: ECA, goal-based, and utility functions.

regards,
John

John Strassner, Ph.D.

-----Original Message-----
From: Supa [mailto:[email-masked]] On Behalf Of Natale, Bob
Sent: Thursday, July 23, 2015 12:40 AM
To: Brian E Carpenter; Juergen Schoenwaelder; Laurent Ciavaglia
Cc: anima; [email-masked]
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent
Importance: Low

Avanti,
BobN

-----Original Message-----
From: Brian E Carpenter [mailto:[email-masked]] 
Sent: Thursday, July 23, 2015 3:11 AM
To: Natale, Bob <[email-masked]>; Laurent Ciavaglia <[email-masked]>; [email-masked]; anima <[email-masked]>
Subject: Re: [Supa] [Anima] SUPA-Intent =? ANMA-Intent

Juergen,

Regards
   Brian

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Thu, 23 Jul 2015 14:54:31 +0000

I believe that we have used the term "Intent" in this context originally in 
   draft-behringer-autonomic-network-framework (June 2012)
which evolved to
   draft-irtf-nmrg-autonomic-network-definitions
and is now 
   RFC7575. 

While I agree that the definition is in the context of an autonomic network and may need to be further refined, it would be nice to acknowledge the original use of the term "Intent" (in its context of course). 

Michael

> From: Anima [mailto:[email-masked]] On Behalf Of John Strassner
> Sent: 23 July 2015 12:17
> To: Natale, Bob; Brian E Carpenter; Laurent Ciavaglia; [email-masked]
> Cc: anima
> NO, SUPA has right now NOT referenced the definition of intent in RFC7575.
> This was because I personally found it too abstract to make use of.
> 
> 
> regards,
> John
> 
> John Strassner, Ph.D.
> AFAIK, the existing posted SUPA documents do not cite RFC 7575 as a source
> for the meaning of intent, but I believe that the RFC 7575 definition matches
> the meaning of the term as it is being used in the SUPA discussions and
> supporting artifacts at present.
> 
> as if that is a well understood phrase. So the first question is whether the
> definition in RFC 7575 is the one assumed in the SUPA documents.
> 
> explicitly to avoid boiling the ocean. Of course we are aware that Intent has
> to be handled later. The current idea is that Intent will most likely be
> > Oscar on the actual use of such technologies. I think that combining SUPA
> and ANIMA solutions could really benefit and simplify the life of operators.
> >
> > just a suggestion to share work that seems connected early in the process
> so that it is more efficient on the long run.
> 
> I'm uncertain whether we can say much more at present. Frankly I would
> hate to see ANIMA bogged down in endless information model discussions
> that are likely to follow any attempt to share an Intent approach with SUPA.
> But if the chairs and ADs see obviously orthogonal approaches emerging in
> the two efforts, that would be a Bad Thing and they should try to prevent it.
> 
>     Brian
>